# Rotating Tree Fractals 
### By: Ritvik Gupta


#### Description
This project is a simple implementation of the rotating tree fractal in Python. The code uses recursion to generate each level of the fractal. It then rotates each generated fractal and outputs each new fractal to an html file after a time delay to form an animation.


#### Function Description

**treeFidget**
- It takes an input for an integer and generates a tree fractal 
- It takes 1 tree and rotates it by 90 degrees 4 times 

**rotateTree**
- It takes a function, an Integer, and a float as an input and outputs a command.
- It takes the tree fractal, the integer to generate the L-system and an angle.
- It then rotates the fractal by the inputted angle.

**changeColour**
- It takes a list of commands as an input and outputs another list of commands.
- Based on the index of the element of the list, it changes the colour of the Pen that is used to generate the L-system.
- The colours are clubbed together based on modular arithmetic with respect to 3.
- - remainder 1 = colour black
- - remainder 2 = colour blue
- - remainder 0 = colour red

**generateAndRotate**
- It takes two integers as its input and outputs an IO() command
- It first generates a list of angles using the first input i teger *numIterations* 
- Next it uses the angles and makes a list of the commands to generate fractals and applies the *changeColour* function to the list
- The last function iterates through the list and uses the *display* function to output to the html file.
- After displaying each fractal it adds a timedelay using the second input *delayMillis* and the *threadDelay* function from the **Control.Concurrent** library.

**main**
- It calls the *generateAndRotate* function with a specified input for both *numIterations* and *delayMillis*


### Acknowledgements 
##### L-System User Notes 
###### Written By: Paul Borke
###### https://paulbourke.net/

##### L-System implementation
###### The University of Edinburgh - FP Tutorial 7